module ProofStack where

data ProofStack a = MkPS [(Formula, a)]

emptyPS :: ProofStack a
emptyPS = MkPS []

pushPS :: Formula -> a -> ProofStack a -> ProofStack a
pushPS f i (MkPS ps) = MkPS ((f,i):ps)

topPS :: ProofStack a -> (Formula, a)
topPS (MkPS []) = error "empty proof stack in topPS"
topPS (MkPS (t:r)) = t

psIsEmpty :: ProofStack a -> Bool
psIsEmpty (MkPS []) = True
psIsEmpty _ = False

popPS :: ProofStack a -> ProofStack a
popPS (MkPS []) = error "empty proof stack in popPS"
popPS (MkPS (_:r)) = MkPS r

topPopPS :: ProofStack a -> (Formula, a, ProofStack a)
topPopPS (MkPS []) = error "empty proof stack in topPopPS"
topPopPS (MkPS ((f,i):r)) = (f,i,r)
