module RedStratTypes where

import Formula
import IOStateMonad
import Auxiliary
import Reduction
import GlobalState

type ReductionStrategy = IOState ()

-- reducers mustn't be applied to irreducible formulae!

-- oldest reduction possibility reducer
type ORPReducer = ForListPartitioner -> ForListPartitioner
  -> ForListPartitioner -> ReductionSelector -> TermSelector
  -> ReductionStrategy

-- literal pair reducer
type LPReducer = LitPairSelector -> DisjSelectType -> TermSelector
  -> ReductionStrategy


----------------------------
-- literal pair selectors --
----------------------------

type LitPairSelector = IOState (Position, Position)


--------------------
-- term selectors --
--------------------

data TermSelType = AnyVar | AnyTerm | AnyOf [Term]

type TermSelector = Position -> TermSelType -> IOState Term

data DisjSelectType = MaxDSel | MinDSel | NormDSel
  deriving (Eq, Show)

